#ifndef __GSK_G_HELPER_H_
#define __GSK_G_HELPER_H_

#include <glib.h>

G_BEGIN_DECLS

void gsk_g_ptr_array_foreach (GPtrArray *array,
			      GFunc      func,
			      gpointer   data);


gpointer gsk_g_tree_min (GTree *tree);
gpointer gsk_g_tree_max (GTree *tree);

GSList *gsk_g_tree_key_slist (GTree *tree);
GSList *gsk_g_tree_value_slist (GTree *tree);
GSList *gsk_g_hash_table_key_slist (GHashTable *table);
GSList *gsk_g_hash_table_value_slist (GHashTable *table);

/* MOVE TO `gskstr.h' ??? */
/* semi-portable 64-bit int parsing functions */
gint64  gsk_strtoll  (const char *str,
		      char      **endp,
		      int         base);
guint64  gsk_strtoull(const char *str,
		      char      **endp,
		      int         base);

guint gsk_strnlen (const char *ptr, guint max_len);

/* MOVE ELSEWHERE ??? */
gboolean gsk_fd_set_nonblocking (int fd);
gboolean gsk_fd_clear_nonblocking (int fd);
gboolean gsk_fd_is_nonblocking (int fd);

/* gsk_g_debug: write debug output */
#ifdef G_HAVE_ISO_VARARGS
#define gsk_g_debug(...)    g_log (G_LOG_DOMAIN,         \
                                   G_LOG_LEVEL_DEBUG,    \
                                   __VA_ARGS__)
#elif defined(G_HAVE_GNUC_VARARGS)
#define gsk_g_debug(format...)      g_log (G_LOG_DOMAIN,         \
                                           G_LOG_LEVEL_DEBUG,    \
                                           format)
#else   /* no varargs macros */
static void
gsk_g_debug (const gchar *format, 
             ...)
{
  va_list args;
  va_start (args, format);
  g_logv (G_LOG_DOMAIN, G_LOG_LEVEL_DEBUG, format, args);
  va_end (args);
}
#endif

G_END_DECLS

#endif
